//Modify QLS settings.
function InitWindow()
{
	this.sizeToContent();

	this.oQLSPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.qls.");

	this.oCustomLocale1 = document.getElementById('qlslocale1');
	this.oCustomLabel1 = document.getElementById('qlslabel1');
	this.oCustomLocale2 = document.getElementById('qlslocale2');
	this.oCustomLabel2 = document.getElementById('qlslabel2');
	this.oCustomLocale3 = document.getElementById('qlslocale3');
	this.oCustomLabel3 = document.getElementById('qlslabel3');
	
	this.oCustomLocale1.value = GetPref("customlocale1");
	this.oCustomLabel1.value = GetPref("customlabel1");
	this.oCustomLocale2.value = GetPref("customlocale2");
	this.oCustomLabel2.value = GetPref("customlabel2");
	this.oCustomLocale3.value = GetPref("customlocale3");
	this.oCustomLabel3.value = GetPref("customlabel3");
	
	var aMItems = GetPref("visiblemenuitems").split("#");
	var iIndex, iLen;
	
	iLen = aMItems.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++) document.getElementById(aMItems[iIndex]).setAttribute("checked", true);
	
	this.oCustomLocale1.focus();
}

function ApplyAndClose()
{
	SetPref("customlocale1", this.oCustomLocale1.value);
	SetPref("customlabel1", this.oCustomLabel1.value);
	SetPref("customlocale2", this.oCustomLocale2.value);
	SetPref("customlabel2", this.oCustomLabel2.value);
	SetPref("customlocale3", this.oCustomLocale3.value);
	SetPref("customlabel3", this.oCustomLabel3.value);

	var oLB = document.getElementById("lbvisiblemenuitems");
    var aItems = new Array();
	var iIndex, iLen;

	iLen = oLB.getRowCount();
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (oLB.getItemAtIndex(iIndex).getAttribute("checked") == "true") //string for some strange reason...
		{
			aItems[aItems.length] = oLB.getItemAtIndex(iIndex).getAttribute("id");
		}
	}
	if (aItems.length > 0)
	{
		SetPref("visiblemenuitems", aItems.join("#"));

		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		oObService.notifyObservers(opener, "qls-settings", "OK");
		window.close();
	}
}

function SelectAllItems(bSelect)
{
	var oList = document.getElementById('lbvisiblemenuitems');
	var iIndex, iLen;
	
	iLen = oList.getRowCount();
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		oList.getItemAtIndex(iIndex).setAttribute("checked", bSelect);
	}
}

function GetPref(sName)
{
	try {return this.oQLSPref.getComplexValue(sName, Components.interfaces.nsIPrefLocalizedString).data;}
	catch (e) {alert(e);}
	return this.oQLSPref.getCharPref(sName);
}

function SetPref(sName, sData)
{
	var oPLS = Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
	oPLS.data = sData;
	this.oQLSPref.setComplexValue(sName, Components.interfaces.nsIPrefLocalizedString, oPLS);
}
